#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>

int CACHETIME = 60; // seconds
typedef unsigned char bool;
enum bool {false, true};

/* this function returns true if the given string consts only of a
   valid ip address */
bool
checkIP(const char *ipstr) {
	bool lastwaspoint;
	const char *i;
	int digs, pnts;

	lastwaspoint = true;
	digs = 0;
	pnts = 0;
	for (i=ipstr+strlen(ipstr)-1; i>=ipstr; i--) {
		if (lastwaspoint) {
			if (*i < '0' && *i > '9') {
				return false;
			}
			digs++;
			lastwaspoint = false;
		} else if (*i >= '0' && *i <= '9') {
			digs++;
		} else {
			if (*i != '.' || digs > 3) {
				return false;
			}
			pnts++;
			digs = 0;
			lastwaspoint = true;
		}
	}
	if (pnts != 3) {
		return false;
	}
	return true;
}
/* this function checks if a file exists in the cache dir about the given
   ip address. If not, the file is updated. A reachable host will result in
   a file with the letter 'on' and else the file will have the data 'off' in
   it. The name of the files is equal to it's ip address. */
void isup(const char *ipstr) {
	char cmd[45] = "ping -c 1 -i 1 123.456.789.123 > /dev/null";
	char filename[30] = "pingcache/123.456.789.123";
	int cmdOff, filenameOff;
	int len;
	FILE *fp;
	struct stat fileinfo;

	// check string
	if (!checkIP(ipstr)) {
		perror(ipstr);
		perror("ip number is invalid");
		return;
	}	

	// make strings
	len = strlen(ipstr);
	cmdOff = 15;
	filenameOff = 10;
/*	if (cmd[cmdOff] != '1' || filename[filenameOff] != '1') {
		perror("programming error in function isup\n");
	}
*/
	strcpy(cmd+15, ipstr);
	memset(cmd+15+len,' ',16-len);
	strcpy(filename+10, ipstr);
	memset(filename+10+len, 0, 16-len);
	
	// get modification date
	if (!stat(filename, &fileinfo)) { 
		if (fileinfo.st_mtime + CACHETIME > time(NULL)) {
			return;
		}
	}

	// perform ping and write output
	fp = fopen(filename, "w");
	if (!fp) {
		return;
	}
	if (system(cmd)) {
		fprintf(fp, "off");
	} else {
		fprintf(fp, "on");
	}
	fclose(fp);
}
/* the main function take ip address as arguments. For each ip address
   the cache file is checked. The main function waits with exiting, for all
   it's children */
int main(int argc, char **argv) {
	int i,status;

	for (i=1; i<argc; i++) {
		if (!fork()) {
			isup(argv[i]);
			return 0;
		}
	}
	for (i=1; i<argc; i++) {
		wait(&status);
	}
	printf("done\n");
	return 0;
}
