#! /usr/local/bin/perl
use strict;

my $fping = '/usr/sbin/fping -A -r1';
my $cachedir = 'pingcache';
my $timeout = 300;

# This code takes a list of ip numbers as arguments. It takes the numbers
# from this list for which the cache file does not exist or is outdated,
# and updates the corresponding file, by running fping.
# Fping runs in parallel, which is faster than sequential pinging.

# make list of outdated pings
my $time = time();
my $list;
foreach (@ARGV) {
	if (-e "$cachedir/$_") {
		my  ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
                      $atime,$mtime,$ctime,$blksize,$blocks) = stat(_);
		if ($time - $mtime > $timeout) {
			$list .= " $_";
		}
	} else {
		$list .= " $_";
	}
}

# update pings
open (FH, "$fping $list 2> /dev/null |");
foreach (<FH>) {
	(my $ip) = m/^(\S*)/;
	open (FG, "> $cachedir/$ip");
	if (m/alive/) {
		print FG "on";
	} else {
		print FG "off";
	}
	close FG;
}
