#!/usr/bin/perl -w
use strict;

use HTML::LinkExtor;
use LWP::Simple qw(get head);
use LWP::UserAgent;

my $ip;
my $checkhtml = 0;

#enable check of other site

if ($ARGV[0]) { #enable per user check
    $ip = $ARGV[0];
}

#$|=1; #flush output instantly and not only at newline
checksite("http://$ip/");

#usage: checksite($url);
#$url is the adres of the site
sub checksite {
    my $base_url = checkSlashEnd($_[0]);
    my $url;
    my $more = 1;
    my %localHTML;  # all local HTML files reachable from homepage, each is a hash with dead URLs and its own URL
    my %otherURL; # all URLs that are not local or not HTML
    my $links;
    $localHTML{$base_url} = undef;
    # spider through entire site by extracting links from HTML files
    while ($more) {
        $more = 0;
        while (($url, $links) = each(%localHTML)) {
            if (!$links) {
                $localHTML{$url}
                    = checkLocalHTML($url, \%localHTML, \%otherURL, $base_url);
                $more = 1;
            }
        }
    }
    #print "\n\n\n";

    # remove duplicates without appended slash
    foreach $url (%localHTML) {
        if (length($url) != length(checkSlashEnd($url))) {
            if (exists($localHTML{checkSlashEnd($url)})) {
                delete($localHTML{$url});
            }
        }
    }
	foreach (keys %localHTML) {
		s/^http:\/\/[^\/]+//;
		print "$_\n";
	}
	foreach (keys %otherURL) {
		s/^http:\/\/[^\/]+//;
		print "$_\n";
	}
}

sub checkLocalHTML {
    my $url = $_[0];
    my $HTMLs = $_[1];
    my $URLs = $_[2];
    my $base_url = $_[3];
    my %links;
    $links{$url} = 1; #make sure its not empty at the end
    my $parser = HTML::LinkExtor->new(undef, checkSlashEnd($url));
    my $content = get($url);
    if (!$content) {
        return \%links;
    }
    $parser->parse($content);
    my @links = $parser->links;
    my $linkarray;
    foreach $linkarray (@links) {
        my @element = @$linkarray;
        my $elt_type = shift @element;
        while (@element) {
            my ($attr_name, $attr_value) = splice(@element, 0 ,2);
            if ($base_url eq substr($attr_value,0,length($base_url))) {
            my $attr_val = $attr_value;
            $attr_value =~ s/#.*$//; # remove #... part
            if ($attr_value =~ m/\?/) {
                $attr_value =~ s/\?.*$//; # remove ?...part
                if ($attr_value !~ m/\./) {
                    $attr_value .= '/';
                }
            }
            if ($attr_val->scheme =~ /\b(ftp|https?|file)\b/
                && !exists($links{$attr_value})) {
                if (exists($HTMLs->{$attr_value})) {
                    #print "HTML already found in other page\n";
                    $links{$attr_value} = 1;
                } elsif (exists($URLs->{$attr_value})) {
                    $links{$attr_value} = $URLs->{$attr_value};
                    #print "URL already found in other page\n";
                } else {
                    #print " $attr_value: h ";
                    my $conttype = headd($attr_value);
                    if ($conttype) {
                        if ($conttype eq 'text/html') {
                            $HTMLs->{$attr_value} = undef;
                            #print "new HTML\n";
                        } else {
                            $URLs->{$attr_value} = 1;
                            #print "new otherr\n";
                        }
                        $links{$attr_value} = 1;
                    } else {
                        # print "c ";
                        if (gett($attr_value)) {
                            $URLs->{$attr_value} = 1;
                            $links{$attr_value} = 1;
                            #print "new other\n";
                        } else {
                            $URLs->{$attr_value} = 0;
                            $links{$attr_value} = 0;
                            #print "new DEAD!!!\n";
                        }
                    }
                }
            } else {
                #print "not processed\n";
            }}
        }
    }
    # delete valid links from local hash
    my $key;
    while (($key, $content) = each(%links)) {
        if ($content && !($key =~ m/^$url$/)
            && length($key) == length(checkSlashEnd($key))) {
            delete($links{$key});
        }
    }
    return \%links;
}

# usage checkSlashEnd($url)
# if a HTML URL has no dot before the last slash or question mark, it's probably a directory
# in that case it needs a slash appended. This will be returned
sub checkSlashEnd {
    my $url = $_[0];
    if ($url =~ m/\/$/) {
        return $url;
    }
    my $revurl = reverse($url);
    my $byte;
    ($byte, @_) = split("\/", $revurl);
    if ($byte =~ m/\./ || $byte =~ m/\?/) {
    	return $url;
    } else {
    	return $url."/";
    }
}

# local head function used to avoid some long hangs
sub headd {
    my $url = $_[0];
    my $ua = LWP::UserAgent->new();
    #$ua->timeout(30);
    #$SIG{ALRM} = sub {die "timeout"};
    my $head;
    #eval {
    #   alarm(30);
        $head = $ua->request(HTTP::Request->new("HEAD", $url));
    #   alarm(0);
    #};
    if ($@) {
        return 0;
    }
    my $conttype;
    if ($head && $head->is_success) {
        if (exists($head->{"_headers"})) {
            $head = $head->{"_headers"};
            if (exists($head->{"content-type"})) {
                $conttype = $head->{"content-type"};
            }
        }
    } elsif ($head && $head->{"_rc"} == 403) {
        $conttype = 1;
    }
    return $conttype;
}

#local get function used to avoid some long hangs
sub gett {
    my $url = $_[0];
    my $ua = LWP::UserAgent->new();
    #$ua->timeout(30);
    #$ua->max_size(2000);
    #$SIG{ALRM} = sub {die "timeout"};
    my $head;
    #eval {
    #   alarm(30);
        $head = $ua->request(HTTP::Request->new("GET", $url));
    #   alarm(0);
    #};
    if ($@) {
        return 0;
    }
    if ($head && $head->is_success) {
        return 1;
    } elsif ($head && $head->{"_rc"} == 403) {
        return 1;
    }
    return 0;
}
