/* Originally from http://www.sateh.com/hacks/crc.php */
#include <stdio.h>
#include <string.h> /* Added to compile on linux */
#include <stdlib.h> /* Added to compile on linux */

#define POLYNOMIAL 0x5C22DB93L

static unsigned long crc_table[256];

void gen_crc_table()
/* generate the table of CRC remainders for all possible bytes */
{
    register int    i, j;
    register unsigned long crc_accum;
    for (i = 0; i < 256; i++) {
	crc_accum = ((unsigned long)i << 24);
	for (j = 0; j < 8; j++) {
	    if (crc_accum & 0x80000000L)
		crc_accum = (crc_accum << 1) ^ POLYNOMIAL;
	    else
		crc_accum = (crc_accum << 1);
	}
	crc_table[i] = crc_accum;
    }
    return;
}

unsigned long update_crc(unsigned long crc_accum, char *data_blk_ptr, int data_blk_size)
{
    register int    i, j;
    for (j = 0; j < data_blk_size; j++) {
        i = ((int)(crc_accum >> 24) ^ *data_blk_ptr++) & 0xff;
        crc_accum = (crc_accum << 8) ^ crc_table[i];
        }
    return crc_accum;
}

main(int argc, char **argv)
{
    unsigned long rv;
    char buf[100];

    memset(buf, 0, sizeof(buf));
    if (argc != 2) {
	printf("Usage: %s <string>\n", argv[0]);
	exit(1);
    }
    if (strlen(argv[1]) > 32) {
	exit(1);
    }
    gen_crc_table();
    rv = update_crc(0xffffffff, argv[1], strlen(argv[1]));
    printf("%lu\n", ~rv);
}
